"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var Observer = function Observer(obj, update) {
  var $$lastState = obj;
  var $$lastSubscribe = [];

  var skipUpdate = function skipUpdate(key, value) {
    return !isObjectShallowModified($$lastState[key], value);
  };

  var isObjectShallowModified = function isObjectShallowModified(prev, next) {
    if (null == prev || null == next || (typeof prev === "undefined" ? "undefined" : _typeof(prev)) !== "object" || (typeof next === "undefined" ? "undefined" : _typeof(next)) !== "object") {
      return prev !== next;
    }
    var keys = Object.keys(prev);
    if (keys.length !== Object.keys(next).length) {
      return true;
    }
    var key = void 0;
    for (var i = keys.length - 1; i >= 0, key = keys[i]; i--) {
      if (next[key] !== prev[key]) {
        return true;
      }
    }
    return false;
  };

  var handler = {
    set: function set(target, property, value, receiver) {
      if (property === 'subscribe' && typeof value === 'function') {
        $$lastSubscribe = $$lastSubscribe.concat(value);
        return $$lastState;
      }
      if (property === 'unsubscribe' && typeof value === 'function') {
        $$lastSubscribe = $$lastSubscribe.filter(function (subscribe) {
          return subscribe !== value;
        });
      }
      if (!skipUpdate(property, value)) {
        if ($$lastSubscribe.length) {
          $$lastSubscribe.forEach(function (sub) {
            return sub();
          });
        }
        $$lastState[property] = value;
        return Reflect.set(target, property, value);
      }

      return $$lastState;
    },
    get: function get(target, property, receiver) {
      return Reflect.get(target, property);
    },
    ownKeys: function ownKeys(target) {
      return Object.keys(target);
    }
  };

  return new Proxy(obj, handler);
};

exports.default = Observer;